Initial commit

This commit is contained in:
Your Name
2026-04-23 17:07:55 +08:00
commit b7e39e063b
16725 changed files with 1625565 additions and 0 deletions
@@ -0,0 +1,10 @@
[Unit]
Description = Check Host State to set fan failsafe speed
[Service]
Type=simple
Restart=on-failure
ExecStart=/usr/bin/gbs-check-host-state.sh
[Install]
WantedBy=multi-user.target
@@ -0,0 +1,13 @@
#!/bin/bash
state="xyz.openbmc_project.State.Chassis.PowerState.Off"
dbus-monitor --system type='signal',interface='org.freedesktop.DBus.Properties',\
member='PropertiesChanged',arg0namespace='xyz.openbmc_project.State.Chassis' | \
while read -r line; do
grep -q member <<< "$line" && continue
if grep -q $state <<< "$line"; then
echo "Setting failsafe assuming host is off" >&2
systemctl start --no-block gbs-host-s5-set-failsafe
fi
done
@@ -0,0 +1,8 @@
[Unit]
Description=Host is ready to be powered on
Wants=phosphor-ipmi-host.service
After=phosphor-ipmi-host.service
Wants=obmc-console@ttyS1.service
After=obmc-console@ttyS1.service
After=postcode-7seg@seven_seg_disp_val.service
RefuseManualStop=yes
@@ -0,0 +1,15 @@
[Unit]
Description=Increase GBS fan failsafe speed on host kernel entrance
PartOf=host-s0-state.target
Requires=phosphor-pid-control.service
After=phosphor-pid-control.service
Wants=mapper-wait@-xyz-openbmc_project-settings-fanctrl.service
After=mapper-wait@-xyz-openbmc_project-settings-fanctrl.service
[Service]
Type=oneshot
# 255: 100% duty cycle
ExecStart=/usr/bin/gbs-set-failsafe.sh 255
[Install]
WantedBy=host-s0-state.target
@@ -0,0 +1,15 @@
[Unit]
Description=Decrease GBS fan failsafe speed on host shutdown
PartOf=host-s5-state.target
Requires=phosphor-pid-control.service
After=phosphor-pid-control.service
Wants=mapper-wait@-xyz-openbmc_project-settings-fanctrl.service
After=mapper-wait@-xyz-openbmc_project-settings-fanctrl.service
[Service]
Type=oneshot
# 102: 40% duty cycle
ExecStart=/usr/bin/gbs-set-failsafe.sh 102
[Install]
WantedBy=host-s5-state.target
@@ -0,0 +1,14 @@
[Unit]
Description=Set gBMC boot time failsafe
Wants=mapper-wait@-xyz-openbmc_project-state-chassis%i.service
After=mapper-wait@-xyz-openbmc_project-state-chassis%i.service
After=acpi-power-state.service
Before=gbs-sysinit.service
[Service]
Type=exec
ExecStart=/usr/bin/gbs-set-boot-failsafe.sh
RemainAfterExit=yes
[Install]
WantedBy=gbs-host-ready.target
@@ -0,0 +1,35 @@
#!/bin/bash
# Copyright 2021 Google LLC
# Copyright 2021 Quanta Computer Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
main() {
local pgd_val
pgd_val="$(busctl get-property -j xyz.openbmc_project.State.Chassis \
/xyz/openbmc_project/state/chassis0 xyz.openbmc_project.State.Chassis \
CurrentPowerState | jq -r '.["data"]')"
if [[ $pgd_val != 'xyz.openbmc_project.State.Chassis.PowerState.On' ]]; then
echo "Setting failsafe assuming host is off" >&2
systemctl start --no-block gbs-host-s5-set-failsafe
else
echo "Setting failsafe assuming host is running" >&2
systemctl start --no-block gbs-host-s0-set-failsafe
fi
}
# Exit without running main() if sourced
if ! (return 0 2>/dev/null); then
main "$@"
fi
@@ -0,0 +1,53 @@
#!/bin/bash
# Copyright 2021 Google LLC
# Copyright 2021 Quanta Computer Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
target_pwm="$1"
if [ -z "$target_pwm" ]; then
echo "Target_pwm is not set" >&2
exit 1
fi
zone_num="$(busctl tree xyz.openbmc_project.State.FanCtrl | grep -c zone)"
result=0
for (( i = 0; i < zone_num; i++ )); do
retries=4
busctl_error=-1
while (( retries > 0 )) && (( busctl_error != 0 )); do
busctl set-property xyz.openbmc_project.State.FanCtrl /xyz/openbmc_project/settings/fanctrl/zone${i} xyz.openbmc_project.Control.FanSpeed Target t "${target_pwm}"
busctl_error=$?
if (( busctl_error != 0 )); then
#Retry setting failsafe. Swampd may be running but zone aren't yet built
#so sleep a second to let them be built
sleep 1
fi
(( retries-=1 )) || true
done
if (( busctl_error != 0 )); then
echo "Failure setting zone${i} fan failsafe to ${target_pwm}" >&2
result=$busctl_error
else
echo "Setting zone${i} fan failsafe to ${target_pwm}"
fi
done
exit $result